*******************************************************************************
*   - system wspomagajacy prace hurtowni, dzialow zbytu i biur handlowych     *
*******************************************************************************
#include "hmg.ch"
#include "hbcom.ch"
#include "hblang.ch"
#include "simpleio.ch"

REQUEST HB_GT_WIN_DEFAULT
REQUEST HB_LANG_PL852
request HB_CODEPAGE_PL852

*----------------------------------------------------------------------------------*
Function Main
*----------------------------------------------------------------------------------*

_HMG_DefaultIconName := "HURT"
plik_ini:='Hurt32.ini'

update_ini()
czyt_ini()

SET LANGUAGE TO POLISH
SET CODEPAGE TO POLISH

SET MULTIPLE OFF WARNING

set( _SET_CODEPAGE, "PL852" )
hb_LangSelect( 'PL852')

IF GetDesktopWidth() < 800 .OR. GetDesktopHeight() < 600
	MsgStop('Do poprawnej pracy programu wymagana jest rozdzielczo co najmniej 800x600',"Brak wymaganej rozdzielczoci!")
	Quit
ENDIF

aIO:=czyt_ini('SerwerIO')
ipIO:="127.0.0.1"
portIO:="2941"

FOR iIO=1 TO LEN(aIO)
	IF UPPER(aIO[iIO][1])="ADRESIP" .AND. !EMPTY(aIO[iIO][2])
		ipIO:=aIO[iIO][2]
	ENDIF
	IF UPPER(aIO[iIO][1])="PORT" .AND. !EMPTY(aIO[iIO][2])
		portIO:=aIO[iIO][2]
	ENDIF
NEXT iIO

cNetPass		:= 'secret'	// Server Password
nCompressionLevel := 9		// Data Compression Level

*lConnect := netio_connect( cNetServer , nNetPort ,, cNetPass, nCompressionLevel )

if !NETIO_CONNECT(ipIO, portIO,, cNetPass, nCompressionLevel )
	msgstop("Nie mona podczy si do serwera NetIO na adresie "+ipIO)
	quit
endif



DEFINE WINDOW startHurt AT 0 , 0 WIDTH 0 HEIGHT 0 TITLE "Obsuga Obrotu Towarowego" MAIN;
   ON INIT Hurt_32();
   NOSHOW; 
   NOMINIMIZE; 
   NOMAXIMIZE; 
   NOSIZE; 
   NOSYSMENU; 
   ICON "HURT";
   BACKCOLOR Nil;
   NOCAPTION

END WINDOW

ACTIVATE WINDOW startHurt
 

Return Nil

**************************** MAIN *****************************
Procedure Hurt_32
Public sciezka, kluczrob


SETBLINK(.F.)
SETCANCEL(.F.)
SET MARGIN TO 0
SET SCOREBOARD OFF
SET WRAP ON
SET CONFIRM ON
SET DATE ANSI
SET ESCAPE OFF

kluczrob:=''

msgbox("Odczytanie zdalne zbioru stru_ind i ustawienie publicznej zmiennej kluczrob sesji IO")

msgbox("Publiczna zmienna kluczrob sesji IO:"+netio_funcexec("get_stru"))

msgbox("Publiczna zmienna kluczrob sesji klienta:"+kluczrob)

msgbox("Odpytanie publicznej zmiennej kluczrob sesji IO")
msgbox("Publiczna zmienna kluczrob sesji IO:"+netio_funcexec("get_klucz"))

msgbox("Przypisanie zmiennej publiczej kluczrob sesji klienta wartoscia zmiennej kluczrob sesji IO")
kluczrob:=netio_funcexec("get_klucz")
msgbox("Publiczna zmienna kluczrob sesji klienta:"+kluczrob)

msgbox("Reindeksacja zbioru klient")
netio_funcexec("reind_","klient")

msgbox("otwarcie pliku 'klient' w sesji IO")
netio_funcexec("net_use","klient",3,0,.F.,.F.,.T.)

msgbox("odpytanie o otwarcie pliku 'klient' w sesji IO")
msgbox(netio_funcexec("is_open_dbf","klient"))

msgbox("zamkniecie pliku 'klient' w sesji IO")
netio_funcexec("close_dbf","klient")

msgbox("odpytanie o otwarcie pliku 'klient' w sesji IO")
msgbox(netio_funcexec("is_open_dbf","klient"))

msgbox("Reindeksacja zbioru stany")
netio_funcexec("reind_","stany")

msgbox("otwarcie 3 plikw w sesji IO")
netio_funcexec("open_all_dbf")

msgbox("odpytanie o otwarcie pliku 'klient' w sesji IO")
msgbox(netio_funcexec("is_open_dbf","klient"))
msgbox("odpytanie o otwarcie pliku 'stany' w sesji IO")
msgbox(netio_funcexec("is_open_dbf","stany"))
msgbox("odpytanie o otwarcie pliku 'rej_sp' w sesji IO")
msgbox(netio_funcexec("is_open_dbf","rej_sp"))

msgbox("odczytanie danych z pliku 'klient' w sesji IO")
aKl:=netio_funcexec("get_dbf","klient")
msgbox("Pobrano dane, rekordow "+str(len(akl)))

msgbox(aKl[211] , 'Rekord #211')
msgbox(aKl[96] , 'Rekord #96')

msgbox("odczytanie danych z pliku 'rej_sp' w sesji IO")
aRejSp:=netio_funcexec("get_dbf","rej_sp")
msgbox("Pobrano dane, rekordow "+str(len(aRejSp)))

msgbox(aRejSp[1] , 'Rekord #1')
msgbox(aRejSp[8] , 'Rekord #8')

msgbox("zamkniecie plikow w sesji IO")
netio_funcexec("close_dbf","klient")
netio_funcexec("close_dbf","stany")
netio_funcexec("close_dbf","rej_sp")


QUIT

RETURN

*******************************
Function czyt_ini(Sekcja)
Local hIni, cSection, aSect, cKey, wi, SekRet:={}

hIni := hb_IniRead( plik_ini,,,.F.)
FOR EACH cSection IN hIni:Keys
	aSect := hIni[ cSection ]
	FOR EACH cKey IN aSect:Keys
		wi:=aSect[ cKey ]
		cSection:=UPPER(cSection)
		cKey:=UPPER(cKey)
		IF VALTYPE(Sekcja)='C' .AND. UPPER(Sekcja)==cSection
			AADD(SekRet,{cKey,wi})
		ENDIF
	NEXT
NEXT

IF VALTYPE(Sekcja)='C' .AND. !EMPTY(Sekcja)
	Return SekRet
ENDIF


RETURN Nil
*************************************************************		
Function zapisz_ini(Sekcja,dane)
Local hIni, cSection, addsection:=.T., i

hIni := hb_IniRead( plik_ini,,,.F.)

//sprawdz czy jest sekcja w ini
FOR EACH cSection IN hIni:Keys
	IF VALTYPE(cSection)='C' .AND. UPPER(cSection)==UPPER(Sekcja)
		addsection:=.F.
		Sekcja:=cSection
		EXIT
	ENDIF
NEXT

IF addsection
	//dodaj sekcje
	hIni[ Sekcja ] := hb_Hash()
ENDIF

FOR i=1 TO Len(dane)
	hIni[ Sekcja ][ dane[i][1] ] := dane[i][2]
Next i

hb_IniWrite( plik_ini, hIni) 

RETURN Nil
*******************************
Function spr_w_ini(tag,domyslne)
//Sprawdz czy jest nowy tag (jeli nie, to dopisz do tablicy aktualizacji)
IF LEN(aIni)=0 .OR. ASCAN(aIni, {|x| UPPER(x[1])==UPPER(tag)})=0
	AADD(aUpdate, {tag,domyslne})
ENDIF
RETURN Nil
*******************************
Function update_ini()
Local hIni, sekcja
		
PRIV aIni
PRIV aUpdate

IF !FILE(plik_ini)
	hIni := hb_iniNew( .F. )
	hb_IniWrite( plik_ini, hIni) 
ENDIF

sekcja:="SerwerIO"
aUpdate:={}
aIni:=czyt_ini(sekcja)
spr_w_ini('AdresIP','127.0.0.1')
spr_w_ini('PortIP',"2941")
IF LEN(aUpdate)>0
	zapisz_ini(sekcja,aUpdate)				//zapisz do ini
ENDIF

RETURN Nil

