**********************************************************************************
#include "hmg.ch"
*REQUEST HB_GT_WIN_DEFAULT

Function Main
	Public c_TITLE := "Hurt Serwer NetIO"
	Public plikINI:="HurtServerIO.ini"
	Public pListenSocket:=''
	Public nIcon:="MAIN"
	Public nTip:='Hurt Serwer NetIO'
	Public sciezka:=''
	Public kluczrob:="XXXXXXXXXXX"
	Set Multiple Off
	SET LANGUAGE TO POLISH
	SET CODEPAGE TO POLISH


	DEFINE WINDOW Form_1 ;
		AT 0,0 ;
		WIDTH 587 HEIGHT 173 ;
		TITLE 'Konfiguracja - Hurt Serwer NetIO' ;
		MAIN ;
		ICON nIcon ;
		NOTIFYICON nIcon ;
		NOTIFYTOOLTIP nTip ;
		ON NOTIFYCLICK Show_Status();
		ON INIT Start_Server();
		ON RELEASE (MsgBalloon("Serwer zosta wyczony!", c_TITLE, 'WARNING'), IIF(!EMPTY(pListenSocket),netio_ServerStop(pListenSocket, .T.),Nil));
		SYSMENU .F. ;
		VISIBLE .F. ;
		SIZABLE .F.

		menu_notify()
		
		@ 10,10 FRAME Frame_1;
			WIDTH  560;
			HEIGHT 120;
			OPAQUE

		@ 20,20 LABEL Label_1;
			WIDTH  40;
			HEIGHT 20;
			VALUE "Port"

		@ 20,150 TEXTBOX port;
			WIDTH  100;
			HEIGHT 20;
			INPUTMASK "999999"

		@ 50,20 LABEL Label_2;
			WIDTH  120;
			HEIGHT 20;
			VALUE "cieka Hurtu"

		@ 50,150 TEXTBOX sciezka;
			WIDTH  360;
			HEIGHT 20;
			MAXLENGTH 150;

		@ 50,530 BUTTON Button_1;
			CAPTION "...";
			ON CLICK SetProperty( "Form_1","sciezka","Value",GetFolder("cieka Hurtu") );
			WIDTH  30;
			HEIGHT 20

		@ 90,20 BUTTON Button_2;
			CAPTION "Zapisz ustawienia";
			ON CLICK Write_Ini();
			WIDTH  150;
			HEIGHT 28

		@ 90,410 BUTTON Button_3;
			CAPTION "Zamknij";
			ON CLICK Form_1.Hide;
			WIDTH  150;
			HEIGHT 28

	END WINDOW

	CENTER WINDOW Form_1

	ACTIVATE WINDOW Form_1

Return Nil

**********************************************************************************
* Show config window
Function Show_Config()
	Form_1.Restore
Return
**********************************************************************************
* Start the Server
Function Start_Server()
	Local c_Path  := "C:\"
	Local c_Port  := "2941"
	IF !EMPTY(pListenSocket)
		MsgBalloon("Serwer jest ju uruchomiony!", c_TITLE, 'INFO')
		RETURN Nil
	ENDIF
	pListenSocket := ''

	IF !File(plikINI)
		Begin ini file (plikINI)
			Set Section "Ustawienia" ENTRY "Port"   To c_Port
			Set Section "Ustawienia" ENTRY "Sciezka"   To c_Path
		End ini
	Else
		Begin ini file (plikINI)
			Get c_Port   Section "Ustawienia" ENTRY "Port"
			Get c_Path   Section "Ustawienia" ENTRY "Sciezka"
		End Ini
	ENDIF

	Form_1.port.Value := c_Port
	Form_1.sciezka.Value := c_Path
	
	sciezka:=Alltrim(Form_1.sciezka.Value)+'\'
	

	*LOCAL nPort      := 50000
	*LOCAL cIfAddr      := '0.0.0.0'
	*LOCAL cRootDir      := '.'
	lRPC      := .T.
	cPasswd      := 'secret'
	nCompressionLevel   := 9
	nStrategy      := NIL
	*pSockSrv      := NIL


	* Start Server

	*pSockSrv := NETIO_MTSERVER( nPort , cIfAddr , cRootDir , lRPC , cPasswd , nCompressionLevel , nStrategy )

	pListenSocket := netio_mtserver( Val( AllTrim(Form_1.port.Value) ), , AllTrim(Form_1.sciezka.Value), .T. , cPasswd , nCompressionLevel , nStrategy )

	IF EMPTY( pListenSocket )
		nIcon:="STOP"
		SetProperty("Form_1","NOTIFYICON",nIcon)
		MsgBalloon("Nie mona uruchomi serwera!", c_TITLE, 'ERROR')
	ELSE
		nIcon:="MAIN"
		SetProperty( "Form_1","NOTIFYICON",nIcon )
		Show_Status()
	ENDIF
Return Nil

**********************************************************************************
* Stop the Server
Function Stop_Server()
	IF !EMPTY(pListenSocket)
		nIcon:="STOP"
		SetProperty( "Form_1","NOTIFYICON",nIcon )
		pListenSocket := netio_serverstop( pListenSocket, .T. )
  		Show_Status()
	ENDIF
Return Nil

**********************************************************************************
* Show Server status
Function Show_Status()
	IF !EMPTY( pListenSocket )
		MsgBalloon("Serwer uruchomiony na porcie: " ;
		+ AllTrim(Form_1.port.Value) + CHR(13);
		+ "cieka Hurtu: " + AllTrim(Form_1.sciezka.Value)+CHR(13)+ "Zmienna 'kluczrob'="+kluczrob, c_TITLE, 'INFO')
	ELSE
		MsgBalloon("Serwer zosta zarzymany!", c_TITLE, 'WARNING')
		hb_idleSleep( 2 )
	ENDIF
Return Nil

**********************************************************************************
* Restart the Server
Function Restart_Server()
	Stop_Server()
	Start_Server()
Return Nil

**********************************************************************************
* Write the INI file with content in texts box on Form_1 (Config Window)
Function Write_Ini()
	IF File(plikINI)
		fErase(plikINI)
	ENDIF

	Begin ini file (plikINI)
		Set Section "Ustawienia" ENTRY "Port"   To Form_1.port.Value
		Set Section "Ustawienia" ENTRY "Sciezka"   To Form_1.sciezka.Value
	End ini

	Restart_Server()
Return Nil

*--------------------------------------------------------*
Static Procedure MsgBalloon( cMessage, cTitle ,xIkona)
*--------------------------------------------------------*
	Local i := Ascan( _HMG_SYSDATA, GetFormHandle("Form_1") )
	Local isInfo:=.F.
	Local isWarning:=.F.
	Local isError:=.F.

	DO CASE
		CASE xIkona=NIL .OR. UPPER(xIkona)='INFO'
			isInfo:=.T.
		CASE UPPER(xIkona)='WARNING'
			isWarning:=.T.
		CASE UPPER(xIkona)='ERROR'
			isError:=.T.
	ENDCASE

	Default cMessage := "Uruchomienie", cTitle := cTytul

	ShowNotifyInfo( _HMG_SYSDATA[i], .F. , NIL, NIL, NIL, NIL, .F., .F. , .F. )

	ShowNotifyInfo( _HMG_SYSDATA[i], .T. , LoadTrayIcon( GetInstance(), ;
		nIcon ), nTip, cMessage, cTitle , isInfo, isWarning, isError)
	
	menu_notify()

Return
***********************************************************************************
FUNCTION menu_notify()

IF IsNotifyMenuDefined ("Form_1")
	ReleaseNotifyMenu ("Form_1")
	SetProperty("Form_1","NotifyIcon",nIcon)
ENDIF

DEFINE NOTIFY MENU OF Form_1
	ITEM 'O...'		ACTION MsgInfo( 'Serwer NetIO programu Hurt', c_TITLE )
	ITEM 'Konfiguracja'	ACTION Show_Config()
	SEPARATOR
	ITEM 'Zrestartuj Serwer'	ACTION Restart_Server()
	ITEM 'Uruchom Serwer'	ACTION Start_Server()
	ITEM 'Zatrzymaj Serwer'	ACTION Stop_Server()
	SEPARATOR
	ITEM 'Zamknij Serwer'  	ACTION Form_1.Release
END MENU

RETURN Nil
*************************************************************************************
/*
 * C-level
*/
#pragma BEGINDUMP

//#define _WIN32_IE      0x0500
#define HB_OS_WIN_32_USED
//#define _WIN32_WINNT   0x0400
#include <shlobj.h>

#include <windows.h>
#include <commctrl.h>
#include "hbapi.h"

static void ShowNotifyInfo(HWND hWnd, BOOL bAdd, HICON hIcon, LPSTR szText, LPSTR szInfo, LPSTR szInfoTitle, BOOL bInfo, BOOL bWarning, BOOL bError);

HB_FUNC ( SHOWNOTIFYINFO )
{
	ShowNotifyInfo( (HWND) hb_parnl(1), (BOOL) hb_parl(2), (HICON) hb_parnl(3), (LPSTR) hb_parc(4), 
			(LPSTR) hb_parc(5), (LPSTR) hb_parc(6), (BOOL) hb_parl(7), (BOOL) hb_parl(8), (BOOL) hb_parl(9) );
}

static void ShowNotifyInfo(HWND hWnd, BOOL bAdd, HICON hIcon, LPSTR szText, LPSTR szInfo, LPSTR szInfoTitle, BOOL bInfo, BOOL bWarning, BOOL bError)
{
	NOTIFYICONDATA nid;

	ZeroMemory( &nid, sizeof(nid) );

	nid.cbSize		= sizeof(NOTIFYICONDATA);
	nid.hIcon		= hIcon;
	nid.hWnd		= hWnd;
	nid.uID			= 0;
	nid.uFlags		= NIF_INFO | NIF_TIP | NIF_ICON;
	
	if(bInfo)
		nid.dwInfoFlags		= NIIF_INFO;
	
	if(bWarning)
		nid.dwInfoFlags		= NIIF_WARNING;

	if(bError)
		nid.dwInfoFlags		= NIIF_ERROR;

	lstrcpy( nid.szTip, TEXT(szText) );
	lstrcpy( nid.szInfo, TEXT(szInfo) );
	lstrcpy( nid.szInfoTitle, TEXT(szInfoTitle) );

	if(bAdd)
		Shell_NotifyIcon( NIM_ADD, &nid );
	else
		Shell_NotifyIcon( NIM_DELETE, &nid );

	if(hIcon)
		DestroyIcon( hIcon );
}

#pragma ENDDUMP

*******************************************
FUNCTION GetHurt(PoleH)
IF UPPER(ALIAS(8))#'HURT'
	NET_USE('hurt',8,0,.F.,.F.,.F.)
ELSE
	SELECT 8
ENDIF
RETURN &poleH
*********************************************
FUNCTION get_stru()
PUBLIC kluczrob
SELE 1
NET_USE('str_ind',1,0,.F.,.F.,.F.)
kluczrob=''				&&klucz indeksowy dla zbioru roboczego
DO WHILE .NOT.EOF()
	IF !EMPTY(kluczrob)
		kluczrob=kluczrob+'+'
	ENDIF
	IF Field_type='C'
		kluczrob=kluczrob+'UPPER('+ALLTRIM(field_name)+')'
	ELSE
		kluczrob=kluczrob+'STR('+ALLTRIM(field_name)+')'
	ENDIF
	SKIP
ENDDO
CLOSE str_ind
*msgbox(kluczrob,'kluczrob serwerio')
RETURN kluczrob
*********************************************
FUNCTION get_klucz()
*msgbox(kluczrob,'kluczrob serwerio')
RETURN kluczrob
*************procedury locks ****************
FUNCTION NET_USE
Local cPath, cFileName, cExt, cYear, monthyear, sciezkaYear, nIndx, month1, File2
Local c_Path:=''
PARAMETERS file, select, month, ex_use, break, index, cAliasNU, nYear
*month=0 bez,1 biezacy, 2 zadany, 3 jak ostatni, 4 poprzedni, 5xx xx
PRIVATE file1, FileIndx, cAliasNetUse
Private lDostep:=.F., lOpusc:=.F., cCoBlokujemy:='OPEN'
PUBLIC lastmonth, sciezkaIO, sciezka

IF !M->sciezkaIO
	Begin ini file "HurtServerIO.ini"
		Get c_Path   Section "Ustawienia" ENTRY "Sciezka"
	End Ini
	M->sciezka:=Alltrim(c_Path)+'\'
	sciezkaIO:=.T.
ENDIF

cAliasNetUse=cAliasNU
month1=month
file1=file

FileIndx:={}
		
file=M->sciezka+M->file
DO CASE
	CASE UPPER(file1)=='KLIENT'
		AADD(FileIndx,file+'.ntx')
		AADD(FileIndx,file+'_f.ntx')		&&drugi index dla klienta
	
	CASE UPPER(file1)='STANY'
		file2=STRTRAN(UPPER(file),'STANY','KODK')
		AADD(FileIndx,file+'.ntx')
		AADD(FileIndx,file+'n'+'.ntx')		&& stany - nazwa
		AADD(FileIndx,file2+'.ntx')			&& kod kreskowy 1
		AADD(FileIndx,file2+'B'+'.ntx')		&& kod kreskowy 2

	OTHER
		AADD(FileIndx,file+'.ntx')
	
ENDCASE

IF !FILE(file+'.dbf')
	MsgInfo("Brak pliku "+file+".dbf ! Nie mog otworzy bazy.","Bd otwarcia pliku bazy danych")
	IF !break
		MsgStop("Program bdzie zakoczony!","Nie mona kontynuowa programu.")
		CLOSE DATA
		QUIT
	ENDIF
	Return (.F.)
ENDIF

IF index
	//sprawdz czy sa pliki z indeksami
	FOR nIndx=1 TO LEN(FileIndx)
		IF !FILE(FileIndx[nIndx])
			MsgInfo("Brak pliku "+FileIndx[nIndx]+" ! Nie mog otworzy indeksu.","Bd otwarcia pliku indeksowego "+file)
			IF !break
				MsgStop("Program bdzie zakoczony!","Nie mona kontynuowa programu.")
				CLOSE DATA
				QUIT
			ENDIF
			Return (.F.)
		ENDIF
	NEXT nIndx
ENDIF

SELE &select

HB_FNameSplit( M->file, @cPath, @cFileName, @cExt )
IF VALTYPE(cAliasNetUse)='C'
	cAliasNetUse:=cAliasNetUse+cFileName
ELSE
	cAliasNetUse:=cFileName
ENDIF

IF SELECT(cAliasNetUse)#0 .AND. SELECT(cAliasNetUse)#select 
	MsgInfo("Alias "+cAliasNetUse+" jest ju otwarty w obszarze "+ALLTRIM(STR(SELECT(cAliasNetUse)))+"!","Otwarty plik "+M->file)
	Return (.F.)
ENDIF

IF TryOpenFile(file, ex_use, index, cAliasNetUse)
	RETURN (.T.)     &&locked
ENDIF

SELE &select
USE

cNazRek:=UPPER(file)+IF(ex_use, '. Tryb Exclusive.','. Tryb Shared.')

def_okno_loc(break,cNazRek,'SprLock("'+file+'",'+IF(ex_use,'.T.','.F.')+','+IF(index,'.T.','.F.')+')')

Center window wOknoLock
Activate window wOknoLock

Return lDostep
****************************************************************************************************
FUNCTION TryOpenFile()
PARAMETERS file, ex_use, index, cAliasNetUse

DO CASE

	&& exclusive and indexed

	CASE ex_use .AND. index .AND. UPPER(file1)=='KLIENT' 

		USE &file ALIAS &cAliasNetUse EXCLUSIVE 
		IF .NOT.NETERR()
			SET INDEX TO (FileIndx[1]), (FileIndx[2])
		ENDIF
	
	CASE ex_use .AND. index .AND. UPPER(file1)='STANY'
		USE &file ALIAS &cAliasNetUse EXCLUSIVE
		IF .NOT.NETERR()
			IF LEN(FileIndx)=4	
				SET INDEX TO (FileIndx[1]), (FileIndx[2]), (FileIndx[3]), (FileIndx[4])
			ELSE
				//wersja bazy bez kodow kreskowych
				SET INDEX TO (FileIndx[1]), (FileIndx[2])
			ENDIF
		ENDIF
		
 		
	CASE ex_use .AND. index
		USE &file ALIAS &cAliasNetUse EXCLUSIVE 
		IF .NOT.NETERR()
			SET INDEX TO (FileIndx[1])
		ENDIF

	&& exclusive and not indexed
		
	CASE ex_use .AND. .NOT.index      	
		USE &file ALIAS &cAliasNetUse EXCLUSIVE
		
	&& shared and indexed
		
	CASE .NOT. ex_use .AND. index .AND. UPPER(file1)=='KLIENT' 
		
		SET EXCLUSIVE OFF
		USE &file ALIAS &cAliasNetUse 
		IF .NOT.NETERR()
			SET INDEX TO (FileIndx[1]), (FileIndx[2])
		ENDIF
		SET EXCLUSIVE ON
		
	CASE .NOT. ex_use .AND.index .AND. UPPER(file1)='STANY'
		SET EXCLUSIVE OFF
		USE &file ALIAS &cAliasNetUse 
		IF .NOT.NETERR()
			IF LEN(FileIndx)=4	
				SET INDEX TO (FileIndx[1]), (FileIndx[2]), (FileIndx[3]), (FileIndx[4])
			ELSE
				//wersja bazy bez kodow kreskowych
				SET INDEX TO (FileIndx[1]), (FileIndx[2])
			ENDIF
		ENDIF

		SET EXCLUSIVE ON
		
	CASE .NOT. ex_use .AND.index					
		SET EXCLUSIVE OFF
		USE &file ALIAS &cAliasNetUse    		
		IF .NOT.NETERR()
			SET INDEX TO (FileIndx[1])
		ENDIF
		SET EXCLUSIVE ON

	&& shared and not indexed
		
	CASE .NOT. ex_use .AND. .NOT.index	
		SET EXCLUSIVE OFF
		USE &file ALIAS &cAliasNetUse 
		SET EXCLUSIVE ON
   ENDCASE

RETURN (.NOT. NETERR() .AND. jestindex(index))
*************************************************
FUNCTION jestindex(OpenIndx)
Local nIndx, ok:=.T.
IF OpenIndx
	FOR nIndx=1 TO LEN(FileIndx)
		IF EMPTY(INDEXKEY(nIndx))
			MsgStop("Nie mona otworzy indeksu "+FileIndx[nIndx]+" zbioru "+file,"Baza nie ma indeksu. [NET_USE]")
			ok:=.F.
			EXIT
		ENDIF
	NEXT nIndx
ENDIF
RETURN ok
*********************************************************************************
FUNCTION FIL_LOCK
PARAMETERS break
Private lDostep:=.F., lOpusc:=.F., cCoBlokujemy:='FIL'
IF FLOCK()
	RETURN (.T.)     &&locked
ENDIF
	
def_okno_loc(break,'pliku '+ALIAS()+'. Prba blokady pliku.','SprLock()')

Center window wOknoLock
Activate window wOknoLock

RETURN lDostep
**********************************************************************************
FUNCTION ADD_REC
PARAMETERS break
Private lDostep:=.F.,lOpusc:=.F., cCoBlokujemy:='ADD'

APPEND BLANK
IF .NOT. NETERR()
	RETURN (.T.)     &&locked
ENDIF
	
def_okno_loc(break,'pliku '+ALIAS()+'. Prba dopisania rekordu.','SprLock()')

Center window wOknoLock
Activate window wOknoLock

RETURN lDostep
***************************************************************************
FUNCTION REC_LOCK 
Local cNazRek,cKoment,cIP
PARAMETERS break
Private lDostep:=.F., lOpusc:=.F., cCoBlokujemy:='REC'
IF RLOCK()
	RETURN (.T.)     &&locked
ENDIF

cNazRek:=ALIAS()+"->nazwa"
IF TYPE(cNazRek)='C'
	cNazRek:=': "'+ALLTRIM(&cNazRek)+'"'
ELSE
	cNazRek:='.'
ENDIF
cKoment:='pliku '+ALIAS()+'. Prba blokady rekordu'+cNazRek
	
def_okno_loc(break,cKoment,'SprLock()')

Center window wOknoLock
Activate window wOknoLock

RETURN lDostep
************************************************
Function SprLock(file,ex_use,index)
Local nStartSec:=INT(SECONDS()), nCurrSec, cInfo1:="Brak dostpu do danych!", cInfo2:="Czekam na dostp do danych ...."
Forever:=.T.
Declare window wOknoLock

IF !lOpusc
	wOknoLock.E_55_10.Value:=cInfo2
	wOknoLock.BPonow.Visible:=.F.
	wOknoLock.ikona.Refresh

	DO WHILE Forever
		DO CASE
			CASE cCoBlokujemy='REC'
				IF RLOCK()
					lDostep:=.T.	&& locked
					Exit
				ENDIF
			CASE cCoBlokujemy='FIL'
				IF FLOCK()
					lDostep:=.T.	&& locked
					Exit
				ENDIF
			CASE cCoBlokujemy='ADD'
				APPEND BLANK
				IF .NOT. NETERR()
					lDostep:=.T.	&& locked
					Exit
				ENDIF
			CASE cCoBlokujemy='OPEN'
				IF TryOpenFile(file, ex_use, index, cAliasNetUse)
					lDostep:=.T.	&& locked
					Exit
				ENDIF
		ENDCASE
		DO EVENTS
		IF lOpusc
			Exit
		ENDIF
		//po 2 sekundach zmie napis 
		nCurrSec:=INT(SECONDS())
		IF (nCurrSec-nStartSec)>=2
			nStartSec:=nCurrSec
			IF wOknoLock.E_55_10.Value=cInfo1
				wOknoLock.E_55_10.Value:=cInfo2
			ELSE
				wOknoLock.E_55_10.Value:=cInfo1
			ENDIF
			wOknoLock.ikona.Refresh
		ENDIF
	ENDDO

	wOknoLock.E_55_10.Value:=cInfo1
	wOknoLock.BPonow.Visible:=.T.
	wOknoLock.ikona.Refresh
	wOknoLock.Bponow.SetFocus

	IF lDostep .OR. lOpusc
		wOknoLock.Release
	ENDIF
ELSE
	wOknoLock.Release
ENDIF

RETURN Nil
*************************************************
FUNCTION OpuscLock(cNazwaFunk)
IF procname(4)='DOMESSAGELOOP'
	&cNazwaFunk
ENDIF
Return Nil

*************************************************
FUNCTION def_okno_loc(lBreak,cNameplik,cNazwaFunk)

PlayExclamation()

DEFINE WINDOW wOknoLock AT 387 , 477 WIDTH 310 HEIGHT 153 TITLE "Brak dostpu do danych";
	ICON "HURT" MODAL NOSIZE NOSYSMENU;
	ON INIT &cNazwaFunk;
	ON RELEASE SetForegroundWindow(cons_hwnd);
	BACKCOLOR KolTloOkna
	**********************************************************************************************
	*Alternatywne okno Modal -> przej na ten typ , jesli w calosci progam obslugiwany przez GUI 	
	*ICON "HURT" MODAL NOSIZE NOSYSMENU; 
	*ICON "HURT" NOMAXIMIZE NOMINIMIZE NOSIZE;
	**********************************************************************************************
	
	ON KEY ALT+F4 ACTION IF(!lBreak,MsgStop("Nie mona zamkn tego okna!","Oczekiwanie na dostp do danych."),(lOpusc:=.T., OpuscLock(cNazwaFunk)))
	
	IF lBreak
		ON KEY Escape ACTION (IF(TYPE('forever')='L' .AND. forever,forever:=.F.,lOpusc:=.T.), OpuscLock(cNazwaFunk))
	ELSE
		ON KEY Escape ACTION (forever:=.F., OpuscLock(cNazwaFunk))
	ENDIF
	
	LABEL(10,5,300,44,"Prba dostpu do "+cNamePlik,'C')	
	SetProperty('wOknoLock','E_10_5','Autosize',.T.)
	
    LABEL(55,10,280,20,"",'CBI')
    
    DEFINE IMAGE ikona
        ROW    45
        COL    18
        WIDTH  31
        HEIGHT 28
        PICTURE "UWAGA"
        HELPID Nil
        VISIBLE .T.
        STRETCH .F.
        TRANSPARENT .T.
        ACTION Nil
    END IMAGE
    
    DEFINE BUTTON BPonow
        ROW    80
        COL    30
        WIDTH  100
        HEIGHT 28
        ACTION &cNazwaFunk
        CAPTION "Ponw prb"
        VISIBLE .t.
    END BUTTON
    
    DEFINE BUTTON BAnuluj
        ROW    80
        COL    180
        WIDTH  100
        HEIGHT 28
        ACTION (lOpusc:=.T., OpuscLock(cNazwaFunk))      
        CAPTION "Anuluj"
        VISIBLE lBreak
    END BUTTON

END WINDOW

RETURN Nil
*********************************************************************************
FUNCTION Label(nRow,nCol,nSzer,nWys,cTresc,cAtrybut,aKolor,aTlo,cFont,nSize)

cNazEtyk:="E_"+ALLTRIM(STR(nRow))+"_"+ALLTRIM(STR(nCol))

DEFINE LABEL &cNazEtyk
        ROW    nRow
        COL    nCol
        WIDTH  nSzer
        HEIGHT nWys
        VALUE cTresc
        IF ValType(cAtrybut)='C'
        	DO CASE
        		CASE AT('R',UPPER(cAtrybut))#0
        			RIGHTALIGN .T.
        		CASE AT('C',UPPER(cAtrybut))#0
        			CENTERALIGN .T. 
        	ENDCASE
        
        	IF AT('B',UPPER(cAtrybut))#0
        		FONTBOLD .T.
        	ENDIF
	
        	IF AT('I',UPPER(cAtrybut))#0
           	FONTITALIC .T.
          ENDIF

          IF AT('U',UPPER(cAtrybut))#0
        		FONTUNDERLINE .T.
        	ENDIF
        ENDIF
        
        IF ValType(aKolor)='A' 
        	FONTCOLOR aKolor
        ELSE
        	FONTCOLOR KolFontSay
        ENDIF
        
        IF ValType(aTlo)='A'        
        	BACKCOLOR atlo
        ELSE
        	BACKCOLOR KolTloSay
        ENDIF
        
        IF ValType(cFont)='C'        
        	FONTNAME cFont
        ENDIF
        
        IF ValType(nSize)='N'
        	FONTSIZE nSize
        ENDIF
        
        VISIBLE .T.
    END LABEL

RETURN Nil

****************************************************************
FUNCTION reind_(cFile)
LOCAL calias, i, is_ean
IF cFile = NIL .OR. EMPTY(cFile)
	Return .F.
ENDIF
IF NET_USE(cFile,1,0,.T.,.T.,.F.)
	calias=sciezka+ALIAS()
	DO CASE
		CASE UPPER(cFile)='KLIENT'
			INDEX ON regon TO &calias
			calias:=calias+'_f'
			INDEX ON UPPER(firma) TO &calias
		CASE UPPER(cFile)='STANY'
			klucz=kluczrob+'+STR(mg)'
			INDEX ON &klucz TO &calias
			calias=calias+'n'
			INDEX ON UPPER(nazwa) TO &calias
			FOR i=1 TO FCOUNT()
				IF UPPER(FIELD(i))='KODK'
					is_ean=.T.
					EXIT
				ENDIF
			NEXT i
			
			IF is_ean
				calias:=sciezka+'kodk'
				INDEX ON kodk TO &calias
				calias:=calias+'B'
				INDEX ON kodk2 TO &calias
			ENDIF
	ENDCASE
ENDIF
CLOSE 1

RETURN (.T.)


****************************************************************
FUNCTION close_dbf(cAlias)
CLOSE &cAlias
RETURN 
****************************************************************
FUNCTION is_open_dbf(cAlias)
RETURN SELECT(cAlias)#0 
****************************************************************
FUNCTION open_all_dbf()
NET_USE("klient",1,0,.F.,.F.,.T.)
NET_USE("stany",2,0,.F.,.F.,.T.)
NET_USE("rej_sp",3,0,.F.,.F.,.F.)
RETURN 
****************************************************************
FUNCTION get_dbf(cFile)
Local i, j, aDbf:={}, s, cField
IF SELECT(cFile)=0
	NET_USE(cFile,0,0,.F.,.F.,.F.)
ELSE
	SELECT &cFile
ENDIF
GO TOP
j=FCOUNT()
DO WHILE !EOF()
	s:=LEN(aDbf)+1
	aDbf:=ASIZE(aDbf,s)
	aDbf[s]:=ARRAY(j)
	FOR i=1 TO j
		cField:=FIELD(i)
		aDbf[s][i]:=&cField
	NEXT i
	SKIP
ENDDO
RETURN aDbf


